unit U_principal;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls;

type
  TForm1 = class(TForm)
    trv_PlanoC: TTreeView;
    procedure trv_PlanoCKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure trv_PlanoCKeyPress(Sender: TObject; var Key: Char);
    procedure trv_PlanoCEditing(Sender: TObject; Node: TTreeNode;
      var AllowEdit: Boolean);
  private
    function calcularNivelDependente(textoOrigem, adiciona: String): String;
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}


function TForm1.calcularNivelDependente(textoOrigem: String; adiciona : String): String ;
var
  nivel : array [0..20] of integer;
  i, nivelC  : SmallInt;
  niveisTxt  : TStringList;
  saida : String;
begin
  nivelC := 0;
  niveisTxt := TStringList.Create;
  for i := 0 to 20 do
    nivel[i] := -1;
  try
    niveisTxt.Text := StringReplace(textoOrigem, '.', #13, [rfReplaceAll, rfIgnoreCase]);
    for i := 0 to niveisTxt.Count - 2 do
    begin
      nivel[i] := StrToInt(niveisTxt.Strings[i]);
      nivelC := i;
    end;
    if adiciona = '=' then
      if nivel[nivelC + 1] = -1 then
        nivel[nivelC + 1] := 1;
    if adiciona = '+' then
      if nivel[nivelC] = -1 then
        nivel[nivelC] := 1
      else
        nivel[nivelC] := nivel[nivelC] + 1;

    if adiciona = '=' then
      for i := 0 to nivelC + 1 do
        saida := saida + IntToStr(nivel[i]) + '.';
    if adiciona = '+' then
      for i := 0 to nivelC do
        saida := saida + IntToStr(nivel[i]) + '.';

    Result := saida;
  finally
    niveisTxt.Free;
  end;
end;

procedure TForm1.trv_PlanoCEditing(Sender: TObject; Node: TTreeNode;
  var AllowEdit: Boolean);
begin
  if Node.Enabled = False then
  begin
    Application.MessageBox(Pchar(Format('A Conta "%s" foi Cancelada e no pode mais ser reutilizada !',[trv_PlanoC.selected.Text])),
     'Conta Cancelada', MB_ICONINFORMATION);
    AllowEdit := False;
  end;
end;

procedure TForm1.trv_PlanoCKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var
  i, n, ponto, oldV, newV : Integer;
  textoPos : String;
begin
  if ((Key = VK_INSERT) or (key = VK_F2)) then //inserir um item
    if (trv_PlanoC.Selected = nil) then
    begin
      if trv_PlanoC.Items.Count = 0 then
        trv_PlanoC.Items.Add(nil, '1. ')
      else begin
        oldV  := 0;
        newV  := 0;
        //ponto := 0;
        for i := 0 to pred(trv_PlanoC.Items.Count) do
        begin
          n := 1;
          while n <= Length(trv_PlanoC.Items.Item[i].Text) do
          begin
            if (Copy(trv_PlanoC.Items.Item[i].Text, n, 1) = '.') then
            begin
              ponto := n;
              if ponto > 1 then
                newV := StrToInt(Copy(trv_PlanoC.Items.Item[i].Text, 1, ponto - 1));
              if oldV < newV then
              begin
                oldV := newV;
                newV := 0;
              end;
              Break;
            end;
            n := n + 1;
          end;
        end;
        trv_PlanoC.Items.Add(nil, format('%d. ',[oldV + 1]));
      end;
    end else begin
      with trv_PlanoC do
      begin
        Items.BeginUpdate;
        if (Selected.HasChildren = False) then
        begin
          with trv_PlanoC.Items.AddChild(trv_PlanoC.Selected, format('%s ',[calcularNivelDependente(trv_PlanoC.Selected.Text, '=')])) do
            MakeVisible;
        end else begin
          textoPos := trv_PlanoC.Selected.GetLastChild.Text;
          with trv_PlanoC.Items.AddChild(trv_PlanoC.Selected, format('%s ',[calcularNivelDependente(textoPos, '+')])) do
            MakeVisible;
        end;
        Items.EndUpdate;
      end;
    end;

  if (Key = VK_ESCAPE) then //sair da seleo
    trv_PlanoC.Selected := nil;

  if (Key = VK_F4) then
  begin
    if trv_PlanoC.Selected = nil then
      Application.MessageBox('Para poder cancelar uma conta, voc deve selecionar a conta primeiro !', 'Sem Seleo de Conta', MB_ICONWARNING)
    else
      if Application.MessageBox(Pchar(format('Voc deseja cancelar o uso da conta "%s" ?',[ trv_PlanoC.Selected.Text])),
        'Cancelar Conta', MB_ICONQUESTION + MB_YESNO) = mrYes then
          trv_PlanoC.Selected.Enabled := False;
  end;

end;

procedure TForm1.trv_PlanoCKeyPress(Sender: TObject; var Key: Char);
begin
  If CharInSet(key, ['.']) then
  begin
    MessageDlg('No digite ponto (.), o sistema usa esse sinal para nivelar as contas.',
    mtInformation, [mbOK], 0);
    key := #0;
  end;
end;

end.
